#include "driver.h"

extern UINT32 *l_y_skip;

static void draw_sprite_1(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_2(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_3(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_4(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_5(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_6(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_7(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_8(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_9(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_10(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_11(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_12(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_13(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_14(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_15(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_16(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);

static void draw_sprite_1_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_2_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_3_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_4_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_5_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_6_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_7_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_8_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_9_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_10_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_11_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_12_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_13_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_14_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_15_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);
static void draw_sprite_16_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy);


void (*neo_draw_sprite[2][16])(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy) =
{
	{
		draw_sprite_1,  draw_sprite_2,
		draw_sprite_3,  draw_sprite_4,
		draw_sprite_5,  draw_sprite_6,
		draw_sprite_7,  draw_sprite_8,
		draw_sprite_9,  draw_sprite_10,
		draw_sprite_11, draw_sprite_12,
		draw_sprite_13, draw_sprite_14,
		draw_sprite_15, draw_sprite_16
	},
	{
		draw_sprite_1_flipx,  draw_sprite_2_flipx,
		draw_sprite_3_flipx,  draw_sprite_4_flipx,
		draw_sprite_5_flipx,  draw_sprite_6_flipx,
		draw_sprite_7_flipx,  draw_sprite_8_flipx,
		draw_sprite_9_flipx,  draw_sprite_10_flipx,
		draw_sprite_11_flipx, draw_sprite_12_flipx,
		draw_sprite_13_flipx, draw_sprite_14_flipx,
		draw_sprite_15_flipx, draw_sprite_16_flipx
	}
};


/******************************************************************************/

static int bitmap_pitch = 0;

void neogeo_init_sprite(void)
{
    bitmap_pitch = (Machine->scrbitmap->line[1] - Machine->scrbitmap->line[0]) / 2;
}


/******************************************************************************/

#define MASK28  0xf0000000
#define MASK24  0x0f000000
#define MASK20  0x00f00000
#define MASK16  0x000f0000
#define MASK12  0x0000f000
#define MASK8   0x00000f00
#define MASK4   0x000000f0
#define MASK0   0x0000000f


#define SPRITE_INCREMENT_LINE() \
sprite += l_y_skip[l++] * dy;

#define SPRITE_LOW_TILE() \
tile = *sprite;

#define SPRITE_HIGH_TILE() \
tile = *(sprite + 1);

#define SPRITE_ADD_PITCH() \
bitmap += bitmap_pitch;

#define SPRITE_DRAW_PIXEL(x, shift) \
pixel = (tile & MASK##shift); if (pixel) bitmap[x] = paldata[pixel >> shift];

/******************************************************************************/
/* draw sprite no flipx                                                       */
/******************************************************************************/

static void draw_sprite_16(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  4)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 4, 16)
		SPRITE_DRAW_PIXEL( 5, 20)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_DRAW_PIXEL( 7, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 8,  0)
		SPRITE_DRAW_PIXEL( 9,  4)
		SPRITE_DRAW_PIXEL(10,  8)
		SPRITE_DRAW_PIXEL(11, 12)
		SPRITE_DRAW_PIXEL(12, 16)
		SPRITE_DRAW_PIXEL(13, 20)
		SPRITE_DRAW_PIXEL(14, 24)
		SPRITE_DRAW_PIXEL(15, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_15(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  4)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 4, 16)
		SPRITE_DRAW_PIXEL( 5, 20)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 7,  0)
		SPRITE_DRAW_PIXEL( 8,  4)
		SPRITE_DRAW_PIXEL( 9,  8)
		SPRITE_DRAW_PIXEL(10, 12)
		SPRITE_DRAW_PIXEL(11, 16)
		SPRITE_DRAW_PIXEL(12, 20)
		SPRITE_DRAW_PIXEL(13, 24)
		SPRITE_DRAW_PIXEL(14, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_14(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  4)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 4, 16)
		SPRITE_DRAW_PIXEL( 5, 20)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 7,  0)
		SPRITE_DRAW_PIXEL( 8,  4)
		SPRITE_DRAW_PIXEL( 9,  8)
		SPRITE_DRAW_PIXEL(10, 12)
		SPRITE_DRAW_PIXEL(11, 16)
		SPRITE_DRAW_PIXEL(12, 20)
		SPRITE_DRAW_PIXEL(13, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_13(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  4)
		SPRITE_DRAW_PIXEL( 2, 12)
		SPRITE_DRAW_PIXEL( 3, 16)
		SPRITE_DRAW_PIXEL( 4, 20)
		SPRITE_DRAW_PIXEL( 5, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 6,  0)
		SPRITE_DRAW_PIXEL( 7,  4)
		SPRITE_DRAW_PIXEL( 8,  8)
		SPRITE_DRAW_PIXEL( 9, 12)
		SPRITE_DRAW_PIXEL(10, 20)
		SPRITE_DRAW_PIXEL(11, 24)
		SPRITE_DRAW_PIXEL(12, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_12(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  4)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 3, 16)
		SPRITE_DRAW_PIXEL( 4, 20)
		SPRITE_DRAW_PIXEL( 5, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 6,  0)
		SPRITE_DRAW_PIXEL( 7,  4)
		SPRITE_DRAW_PIXEL( 8,  8)
		SPRITE_DRAW_PIXEL( 9, 16)
		SPRITE_DRAW_PIXEL(10, 20)
		SPRITE_DRAW_PIXEL(11, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_11(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  4)
		SPRITE_DRAW_PIXEL( 1,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 3, 20)
		SPRITE_DRAW_PIXEL( 4, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 5,  0)
		SPRITE_DRAW_PIXEL( 6,  4)
		SPRITE_DRAW_PIXEL( 7, 12)
		SPRITE_DRAW_PIXEL( 8, 16)
		SPRITE_DRAW_PIXEL( 9, 24)
		SPRITE_DRAW_PIXEL(10, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_10(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 3, 24)
		SPRITE_DRAW_PIXEL( 4, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 5,  0)
		SPRITE_DRAW_PIXEL( 6,  8)
		SPRITE_DRAW_PIXEL( 7, 16)
		SPRITE_DRAW_PIXEL( 8, 24)
		SPRITE_DRAW_PIXEL( 9, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_9(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 3, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 4,  0)
		SPRITE_DRAW_PIXEL( 5,  8)
		SPRITE_DRAW_PIXEL( 6, 16)
		SPRITE_DRAW_PIXEL( 7, 24)
		SPRITE_DRAW_PIXEL( 8, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_8(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 3, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 4,  0)
		SPRITE_DRAW_PIXEL( 5,  8)
		SPRITE_DRAW_PIXEL( 6, 16)
		SPRITE_DRAW_PIXEL( 7, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_7(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  4)
		SPRITE_DRAW_PIXEL( 1, 12)
		SPRITE_DRAW_PIXEL( 2, 20)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 3,  0)
		SPRITE_DRAW_PIXEL( 4,  8)
		SPRITE_DRAW_PIXEL( 5, 16)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_6(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  4)
		SPRITE_DRAW_PIXEL( 1, 16)
		SPRITE_DRAW_PIXEL( 2, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 3,  0)
		SPRITE_DRAW_PIXEL( 4, 12)
		SPRITE_DRAW_PIXEL( 5, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_5(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  8)
		SPRITE_DRAW_PIXEL( 1, 20)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 2,  0)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 4, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_4(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_DRAW_PIXEL( 1, 16)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 2,  0)
		SPRITE_DRAW_PIXEL( 3, 16)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_3(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0, 12)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 1,  0)
		SPRITE_DRAW_PIXEL( 2, 20)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_2(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 1,  0)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_1(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_ADD_PITCH()
	}
}

/******************************************************************************/
/* draw sprite with flipx                                                     */
/******************************************************************************/

static void draw_sprite_16_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(15,  0)
		SPRITE_DRAW_PIXEL(14,  4)
		SPRITE_DRAW_PIXEL(13,  8)
		SPRITE_DRAW_PIXEL(12, 12)
		SPRITE_DRAW_PIXEL(11, 16)
		SPRITE_DRAW_PIXEL(10, 20)
		SPRITE_DRAW_PIXEL( 9, 24)
		SPRITE_DRAW_PIXEL( 8, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 7,  0)
		SPRITE_DRAW_PIXEL( 6,  4)
		SPRITE_DRAW_PIXEL( 5,  8)
		SPRITE_DRAW_PIXEL( 4, 12)
		SPRITE_DRAW_PIXEL( 3, 16)
		SPRITE_DRAW_PIXEL( 2, 20)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_15_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(14,  0)
		SPRITE_DRAW_PIXEL(13,  4)
		SPRITE_DRAW_PIXEL(12,  8)
		SPRITE_DRAW_PIXEL(11, 12)
		SPRITE_DRAW_PIXEL(10, 16)
		SPRITE_DRAW_PIXEL( 9, 20)
		SPRITE_DRAW_PIXEL( 8, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 7,  0)
		SPRITE_DRAW_PIXEL( 6,  4)
		SPRITE_DRAW_PIXEL( 5,  8)
		SPRITE_DRAW_PIXEL( 4, 12)
		SPRITE_DRAW_PIXEL( 3, 16)
		SPRITE_DRAW_PIXEL( 2, 20)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_14_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(13,  0)
		SPRITE_DRAW_PIXEL(12,  4)
		SPRITE_DRAW_PIXEL(11,  8)
		SPRITE_DRAW_PIXEL(10, 12)
		SPRITE_DRAW_PIXEL( 9, 16)
		SPRITE_DRAW_PIXEL( 8, 20)
		SPRITE_DRAW_PIXEL( 7, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 6,  0)
		SPRITE_DRAW_PIXEL( 5,  4)
		SPRITE_DRAW_PIXEL( 4,  8)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 1, 20)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_13_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(12,  0)
		SPRITE_DRAW_PIXEL(11,  4)
		SPRITE_DRAW_PIXEL(10, 12)
		SPRITE_DRAW_PIXEL( 9, 16)
		SPRITE_DRAW_PIXEL( 8, 20)
		SPRITE_DRAW_PIXEL( 7, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 6,  0)
		SPRITE_DRAW_PIXEL( 5,  4)
		SPRITE_DRAW_PIXEL( 4,  8)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 2, 20)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_12_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(11,  0)
		SPRITE_DRAW_PIXEL(10,  4)
		SPRITE_DRAW_PIXEL( 9,  8)
		SPRITE_DRAW_PIXEL( 8, 16)
		SPRITE_DRAW_PIXEL( 7, 20)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 5,  0)
		SPRITE_DRAW_PIXEL( 4,  4)
		SPRITE_DRAW_PIXEL( 3,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 1, 20)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_11_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL(10,  4)
		SPRITE_DRAW_PIXEL( 9,  8)
		SPRITE_DRAW_PIXEL( 8, 16)
		SPRITE_DRAW_PIXEL( 7, 20)
		SPRITE_DRAW_PIXEL( 6, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 5,  0)
		SPRITE_DRAW_PIXEL( 4,  4)
		SPRITE_DRAW_PIXEL( 3, 12)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_10_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 9,  0)
		SPRITE_DRAW_PIXEL( 8,  8)
		SPRITE_DRAW_PIXEL( 7, 16)
		SPRITE_DRAW_PIXEL( 6, 24)
		SPRITE_DRAW_PIXEL( 5, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 4,  0)
		SPRITE_DRAW_PIXEL( 3,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_9_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 8,  0)
		SPRITE_DRAW_PIXEL( 7,  8)
		SPRITE_DRAW_PIXEL( 6, 16)
		SPRITE_DRAW_PIXEL( 5, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 4,  0)
		SPRITE_DRAW_PIXEL( 3,  8)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_DRAW_PIXEL( 1, 24)
		SPRITE_DRAW_PIXEL( 0, 28)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_8_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 7,  0)
		SPRITE_DRAW_PIXEL( 6,  8)
		SPRITE_DRAW_PIXEL( 5, 16)
		SPRITE_DRAW_PIXEL( 4, 24)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 3,  0)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 1, 16)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_7_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 6,  4)
		SPRITE_DRAW_PIXEL( 5, 12)
		SPRITE_DRAW_PIXEL( 4, 20)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 3,  0)
		SPRITE_DRAW_PIXEL( 2,  8)
		SPRITE_DRAW_PIXEL( 1, 16)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_6_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 5,  4)
		SPRITE_DRAW_PIXEL( 4, 16)
		SPRITE_DRAW_PIXEL( 3, 28)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 2,  0)
		SPRITE_DRAW_PIXEL( 1, 12)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_5_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 4,  8)
		SPRITE_DRAW_PIXEL( 3, 20)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 2,  0)
		SPRITE_DRAW_PIXEL( 1, 12)
		SPRITE_DRAW_PIXEL( 0, 24)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_4_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 3,  0)
		SPRITE_DRAW_PIXEL( 2, 16)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 1,  0)
		SPRITE_DRAW_PIXEL( 0, 16)
		SPRITE_ADD_PITCH()
	}
}

static void draw_sprite_3_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 2, 12)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 1,  0)
		SPRITE_DRAW_PIXEL( 0, 20)
		SPRITE_ADD_PITCH()
	}
}

static void draw_sprite_2_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_LOW_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 1,  0)
		SPRITE_ADD_PITCH()
	}
}


static void draw_sprite_1_flipx(UINT32 *sprite, UINT16 *bitmap, UINT32 *paldata, int zy, int dy)
{
	UINT32 tile, pixel;
	int l = 0;

	while (zy--)
	{
		SPRITE_INCREMENT_LINE()
		SPRITE_HIGH_TILE()
		SPRITE_DRAW_PIXEL( 0,  0)
		SPRITE_ADD_PITCH()
	}
}
